import dbus
import os
import sys
import time
from gi.repository import Gio

"""
MOD_ALT         = 0x1
MOD_CONTROL     = 0x2
MOD_NOREPEAT    = 0x4000
MOD_SHIFT       = 0x4
MOD_WIN         = 0x8
"""
kay_map_win2ky = {
    0x1:"Alt",
    0x2:"Ctrl",
    0x4:"Shift",
    0x8:"Win",
    0x4000:"",
    }
def get_window_shortcut(proxy):
    shortcutInfos=None
    try:
        shortcutInfos = proxy.getShortcutInfos(dbus_interface='org.ukui.KWin')
    except:
        print('getShortcutInfos call failed')
        pass
    return shortcutInfos
    
#session_bus = dbus.SessionBus()

#proxy = session_bus.get_object('org.ukui.KWin', '/KWin')
#print(get_window_shortcut(proxy))
#session_bus.close()
#proxy_dev = dbus.Interface(proxy, dbus_interface='org.ukui.KWin')
#_iface = dbus.Interface(proxy, dbus.PROPERTIES_IFACE)
#print(_iface.Get('org.ukui.KWin', 'currentDesktop'))
#proxy.

def fliter_not_shortcut(str):
    tmp=['active', 'volume-step', 'priority', 'enable-osd']
    for a in tmp:
        if (str==a):
            return False
    return True
def get_exist_shortcut():
    lst=[]
    source = Gio.SettingsSchemaSource.get_default()
    if source.lookup("org.ukui.SettingsDaemon.plugins.media-keys", True) is None:
        print("0")
    else:
        print(source)
        sys_shortcur = Gio.Settings.new("org.ukui.SettingsDaemon.plugins.media-keys")
        apps_infos=sys_shortcur.list_keys()
        for app in apps_infos:
            if fliter_not_shortcut(app):
                value = "{}".format(sys_shortcur.get_value(app))
                if value.__len__() > 2 and value.find('XF86') < 0:
                    if value.find('KP_Delete') > -1:
                        value = "<Ctrl><Alt>Del"
                    lst.append(value.replace("'", ""))
        return lst

def exec_shell(cmd):
    try:
        print(cmd)
        return os.popen(cmd).closed
    except:
        return 123
def create_custom_shortcut(name, binding, action, path):
    if name.__len__() < 1 or binding.__len__() < 1 or action.__len__() < 1 or path.__len__() < 1:
        print("invalid args")
        return
    source = Gio.SettingsSchemaSource.get_default()
    if source.lookup("org.ukui.control-center.keybinding", True) is None:
        exit(4)
    else:
        err = exec_shell("gsettings set org.ukui.control-center.keybinding:{} name {}".format(path, name))
        if err !=0:
            print("exec set name error:{}".format(err))
        err = exec_shell("gsettings set org.ukui.control-center.keybinding:{} binding \"{}\"".format(path, binding))
        if err !=0:
            print("exec set binding error:{}".format(err))

        err = exec_shell("gsettings set org.ukui.control-center.keybinding:{} action {}".format(path, action))
        if err !=0:
            print("exec set action error:{}".format(err))
def del_custom_shortcut(path, name):
    exec_shell("dconf reset -f {}{}".format(path, name))
def read_path(path):
    try:
        str = os.popen("dconf list {}".format(path)).read()
        customs = str.split("\n")
        max_index=0
        for exsit_path in customs:
            exsit_path= exsit_path.replace("/", "")
            offset = exsit_path.find("custom")
            if  offset > -1:
                if max_index < int(exsit_path[offset + 6:]):
                    max_index = int(exsit_path[offset + 6:])
        return "custom{}/".format(max_index+1)
    except:
        print("get new path failed")
        return ""

# hwnd, hotkey_id, lp must be hex
def write_shell(file_name, bottle, hwnd, hotkey_id, lp="0"):
    print("file name:", file_name)
    buf="""#!/usr/bin/bash
WINEPREFIX={} kylin-wine sendmessage.exe {} 0x312 {} {}
""".format(bottle, hwnd, hotkey_id, lp)
    print(buf)
    with open(file_name, 'w') as f:
        f.write(buf)
    os.chmod(file_name, 0o755)

# hwnd, hotkey_id, lp must be hex
def write_desktop(file_name, shell_path, name):
    print("file name:", file_name)
    if name.__len__() == 0:
        name="test"
    buf="""#!/usr/bin/env xdg-open

[Desktop Entry]
Encoding=UTF-8
Type=Application
StartupNotify=true
Name={}
Exec="{}"
""".format(name, shell_path)
    print(buf)
    with open(file_name, 'w') as f:
        f.write(buf)

def get_custom_exist(path):
    lst=[]
    try:
        str = os.popen("dconf list {}".format(path)).read()
        customs = str.split("\n")
        max_index=0
        for exsit_path in customs:
            offset = exsit_path.find("custom")
            if offset > -1:
                try:
                    binding = os.popen("gsettings get org.ukui.control-center.keybinding:{}{} binding".format(path, exsit_path)).read().replace("\n", "").replace("'", "")
                    name = os.popen("gsettings get org.ukui.control-center.keybinding:{}{} name".format(path, exsit_path)).read().replace("\n", "").replace("'", "")
                    action = os.popen("gsettings get org.ukui.control-center.keybinding:{}{} action".format(path, exsit_path)).read().replace("\n", "").replace("'", "")
                    lst.append((name.replace("\n", ""), binding.replace("\n", ""), action.replace("\n", ""), exsit_path))
                except:
                    print(exsit_path)
                    continue
        return lst
    except:
        print("get new path failed")
        return lst
def usage(self_path):
    print("usage: python3 {} create <modifiers> <vkey> <bottle> <hwnd> <hotkey_id>".format(self_path))
    print("       python3 {} delete <modifiers> <vkey> <bottle>".format(self_path))
    print("       python3 {} clean <bottle>".format(self_path))
    exit(5)

def clean_bottle_desktop_file(bottle):
    if not os.path.exists(bottle):
        print("bottle {} is not exist".format(bottle))
        exit(6)
    for entry in os.scandir(bottle):
        if entry.is_file():
            file_path=entry.path
            if file_path.lower().endswith('desktop') or file_path.lower().endswith('sh'):
                dirStr, ext = os.path.splitext(file_path)
                name=dirStr.split('/')[-1]
                if (name.__len__() > 0):
                    if ext == ".desktop" :
                        del_custom_shortcut("/org/ukui/desktop/keybindings/", name+'/')
                    os.remove(file_path)
                print(file_path, name)
    custom_lst=get_custom_exist("/org/ukui/desktop/keybindings/")
    for shortcut in custom_lst:
        exsited_dir=os.path.dirname(shortcut[2])
        if (not os.path.exists(shortcut[2])) and (os.path.abspath(bottle) == os.path.abspath(exsited_dir)):
            print("clean old shortcut : ", shortcut)
            del_custom_shortcut("/org/ukui/desktop/keybindings/", shortcut[3])

print(sys.argv.__len__(), sys.argv)

if sys.argv.__len__() != 3 and sys.argv.__len__() != 5 and sys.argv.__len__() != 7:
    usage(sys.argv[0])

if sys.argv[1].lower() !="create" and sys.argv[1].lower() !="delete" and sys.argv[1].lower() !="clean":
    usage(sys.argv[0])

if sys.argv[1].lower() =="clean":
    bottle=sys.argv[2]
    clean_bottle_desktop_file(bottle)
    exit(0)
test_modifiers=sys.argv[2]
kylin_modifiers=""
win32_vk=sys.argv[3]
win32_modifiers=int(test_modifiers)
create_shortcut=sys.argv[1].lower() =="create"
if win32_modifiers < 0:
    print("error modifiers")
    exit(1)
if win32_vk.__len__() != 1:
    print("error vk")
    exit(2)

if ord(win32_vk[0]) < 0x41 or ord(win32_vk[0]) > 0x5a:
    print("error vk, only allow A-Z")
    exit(2)

if win32_modifiers & 0x2:
    kylin_modifiers+="<{}>".format(kay_map_win2ky[0x2])
if win32_modifiers & 0x1:
    kylin_modifiers+="<{}>".format(kay_map_win2ky[0x1])
if win32_modifiers & 0x4:
    kylin_modifiers+="<{}>".format(kay_map_win2ky[0x4])
if win32_modifiers & 0x8:
    kylin_modifiers+="<{}>".format(kay_map_win2ky[0x8])
kylin_modifiers+=win32_vk.lower()

lst=get_exist_shortcut()
find_custom_exist=None
for shortcut in lst:
    #print(shortcut)
    if shortcut == kylin_modifiers:
        print("exsited: ", shortcut)
        exit(3)

bottle=sys.argv[4]
if not os.path.exists(bottle):
    print("bottle {} is not exist".format(bottle))
    exit(6)
custom_lst=get_custom_exist("/org/ukui/desktop/keybindings/")
for shortcut in custom_lst:
    if shortcut[1] == kylin_modifiers:
        if create_shortcut:
            #print("customs exsited: ", shortcut)
            exsited_dir=os.path.dirname(shortcut[2])
            if (not os.path.exists(shortcut[2])) and (os.path.abspath(bottle) == os.path.abspath(exsited_dir)):
                del_custom_shortcut("/org/ukui/desktop/keybindings/", shortcut[3])
                print("clean old shortcut : ", shortcut)
                time.sleep(0.05);
            else:
                print("exsited: ", shortcut)
                exit(3)
        find_custom_exist=shortcut
        break

new_name = read_path("/org/ukui/desktop/keybindings/")
desktop_path=os.path.join(bottle, new_name.replace('/', "")) + '.desktop'
shell_path=os.path.join(bottle, new_name.replace('/', "")) + '.sh'
#delete shortcut
if not create_shortcut:
    if find_custom_exist:
        print(kylin_modifiers, find_custom_exist)
        del_custom_shortcut("/org/ukui/desktop/keybindings/", find_custom_exist[3])
        old_desktop_path=os.path.join(bottle, find_custom_exist[3].replace('/', "")) + '.desktop'
        if os.path.exists(old_desktop_path):
            os.remove(old_desktop_path)
        else:
            print("{} is not exist".format(old_desktop_path))
        old_shell_path=os.path.join(bottle, find_custom_exist[3].replace('/', "")) + '.sh'
        if os.path.exists(old_shell_path):
            os.remove(old_shell_path)
        exit(0)
    else:
        print("Not found shortcut " + kylin_modifiers)
        exit(0)

# create shortcut
hwnd=sys.argv[5]
hotkey_id=sys.argv[6]
if hwnd.__len__() < 1:
    print("hwnd {} is null".format(hwnd))
    exit(6)
if hwnd.__len__() < 1:
    print("hwnd {} is null".format(hwnd))
    exit(6)
if int(hwnd, 16) == 0:
    print("hwnd {} is not digit".format(hwnd))
    exit(6)

if os.path.exists(desktop_path):
    print("{} was exist, please check".format(desktop_path))
    exit(12)

if os.path.exists(shell_path):
    print("{} was exist, please check".format(shell_path))
    exit(13)

write_shell(shell_path, bottle, hwnd, hotkey_id, hex(ord(win32_vk[0])<<16 |win32_modifiers))
if not os.path.exists(shell_path):
    print("write shell file {} failed.".format(shell_path))
    exit(14)

tmp_lst=bottle.split('/')
name=tmp_lst[-1]
if name.__len__() == 0:
    name=tmp_lst[-2]


write_desktop(desktop_path, shell_path, name)
if not os.path.exists(desktop_path):
    print("write desktop file {} failed.".format(desktop_path))
    os.remove(shell_path)
    exit(15)
create_custom_shortcut("wine_shortcut_" + name + "_" + new_name.replace('/', ""), kylin_modifiers, desktop_path, "/org/ukui/desktop/keybindings/{}".format(new_name))

"""
org.kde.kglobalaccel
    kglobalaccel
        org.kde.KGlobalAccel
"""
